package kiev;

import kiev.stdlib.*;
import kiev.vlang.*;
import kiev.parser.*;

import java.io.*;
import java.util.*;

public class Main {

	public static DataInputStream input;

	public static void main(String[] args) {
start:
		Kiev.programm_start = Kiev.programm_end = System.currentTimeMillis();
		long curr_time = 0L, diff_time = 0L;
		boolean delayed_stop = false;
		ASTFileUnit[] file_unit;
		java.io.InputStream file_input_stream;
		int a = 0;
		if( args==null ) args = new String[0];
		int alen = args.length;
		try {
			for(; a < alen ;a++) {
				if( args[a].equals("-?") || args[a].equals("-h") || args[a].equals("-help") ) {
					printHelp();
					goto stop;
				}	
				else if( args[a].equals("-prompt")) {
					Kiev.errorPrompt = true;
					args[a] = null;
				}
				else if( args[a].equals("-g")) {
					Kiev.debugoutput = true;
					args[a] = null;
				}
				else if( args[a].equals("-debug")) {
					args[a] = null;
					String dbg = args[++a];
					args[a] = null;
					System.out.println("Debugging: ");
					if( dbg.indexOf("stat",0) >= 0 ) {
						System.out.println("\tstatement generation");
						Kiev.debugStatGen	= true;
					}
					if( dbg.indexOf("asm",0) >= 0 ) {
						System.out.println("\tassembler generation");
						Kiev.debugAsmGen		= true;
					}
					if( dbg.indexOf("instr",0) >= 0 ) {
						System.out.println("\tinstractions generation");
						Kiev.debugInstrGen	= true;
					}
					if( dbg.indexOf("bcwrite",0) >= 0 ) {
						System.out.println("\tbytecode .class generation");
						Kiev.debugBytecodeGen = true;
					}
					if( dbg.indexOf("bcread",0) >= 0 ) {
						System.out.println("\tbytecode .class reading");
						Kiev.debugBytecodeRead = true;
					}
					if( dbg.indexOf("resolv",0) >= 0 ) {
						System.out.println("\tidentifier resolving");
						Kiev.debugResolve	= true;
					}
					if( dbg.indexOf("operat",0) >= 0 ) {
						System.out.println("\toperator resolving");
						Kiev.debugOperators	= true;
					}
					if( dbg.indexOf("flags",0) >= 0 ) {
						System.out.println("\tflags change for members");
						Kiev.debugFlags		= true;
					}
					if( dbg.indexOf("member",0) >= 0 ) {
						System.out.println("\tmembers attaching (AST generation)");
						Kiev.debugMembers	= true;
					}
					if( dbg.indexOf("create",0) >= 0 ) {
						System.out.println("\tmembers creation");
						Kiev.debugCreation	= true;
					}
					if( dbg.indexOf("ast",0) >= 0 ) {
						System.out.println("\tAST tree");
						Kiev.debugAST		= true;
					}
					if( dbg.indexOf("profile",0) >= 0 ) {
						System.out.println("\tProfile counts");
						Kiev.debugProfile	= true;
					}
					if( dbg.indexOf("methodtrace",0) >= 0 ) {
						System.out.println("\tMethod tracing");
						Kiev.debugMethodTrace	= true;
					}
					if( dbg.indexOf("multimethod",0) >= 0 ) {
						System.out.println("\tMultiMethod generation");
						Kiev.debugMultiMethod	= true;
					}
					if( dbg.indexOf("rule",0) >= 0 ) {
						System.out.println("\trules");
						Kiev.debugRules		= true;
					}
					Kiev.debug = true;
					continue;
				}
				else if( args[a].equals("-trace")) {
					args[a] = null;
					String dbg = args[++a];
					args[a] = null;
					System.out.println("Tracing: ");
					if( dbg.indexOf("rules",0) >= 0 ) {
						System.out.println("\tprolog rules");
						Kiev.traceRules		= true;
						kiev.stdlib.PEnv.debug = true;
					}
					Kiev.debug = true;
					continue;
				}
				else if( args[a].equals("-verbose") || args[a].equals("-v") ) {
					Kiev.verbose = true;
					args[a] = null;
					continue;
				}
				else if( args[a].equals("-verify") ) {
					Kiev.verify = true;
					args[a] = null;
					continue;
				}
				else if( args[a].equals("-d")) {
					args[a] = null;
					Kiev.output_dir = args[++a];
					args[a] = null;
					continue;
				}
				else if( args[a].equals("-p") || args[a].equals("-project") ) {
					args[a] = null;
					Kiev.project_file = new File(args[++a]);
					args[a] = null;
					continue;
				}
				else if( args[a].equals("-makedep") ) {
					args[a] = null;
					Kiev.interface_only = true;
					args[a] = null;
					continue;
				}
				else if( args[a].equals("-make") ) {
					args[a] = null;
					Kiev.make_project = true;
					continue;
				}
				else if( args[a].equals("-makeall") ) {
					args[a] = null;
					Kiev.make_project = true;
					Kiev.makeall_project = true;
					continue;
				}
				else if( args[a].equals("-classpath")) {
					args[a] = null;
					Kiev.compiler_classpath = args[++a];
					args[a] = null;
					Kiev.initialized = false;
					continue;
				}
				else if( args[a].equals("-gc")) {
					args[a] = null;
					Kiev.gc_mem = (long)(Double.valueOf(args[++a]).doubleValue()*1024.D);
					args[a] = null;
					continue;
				}
				else if( args[a].equals("-s")) {
					Kiev.source_only = true;
					args[a] = null;
					continue;
				}
				else if( args[a].equals("-i") || args[a].equals("-incremental")) {
					Kiev.interactive = true;
					Kiev.make_project = true;
					args[a] = null;
					continue;
				}
				else if( hasWildcards(args[a]) ) {
					try {
						args = addExpansion(args,a);
					} catch( IOException e ) {
						Kiev.reportError(0,"Error in arguments: "+e);
					}
				}
			}

			String[] args1 = new String[0];
			for(int i=0; i < args.length; i++) {
				if( args[i] == null ) continue;
				args1 = (String[])Arrays.appendUniq(args1,args[i]);
			}
			args = args1;
		} catch( ArrayIndexOutOfBoundsException e) {
			args = new String[0];
		} catch( Exception e) {
			Kiev.reportError(0,e);
			goto stop;
		}
		
		try {
			if( Kiev.debugMethodTrace ) {
				Runtime.getRuntime().traceMethodCalls(true);
			} else {
				Runtime.getRuntime().traceMethodCalls(false);
			}

			if( !Kiev.initialized )
				Env.InitializeEnv(Kiev.compiler_classpath);

			if( Kiev.make_project )		
				args = addRequaredToMake(args);
			
			if( args.length == 0 ) {
				if( Kiev.verbose )
					System.out.println("All files are up to date\007\007");
					goto stop;
			}

			if( !Kiev.initialized ) {
				Type.InitializeTypes();
				Kiev.initialized = true;
			}

		} catch( Exception e) {
			Kiev.reportError(0,e);
			goto stop;
		}

		try {
			if( Kiev.verbose ) System.out.println(Kiev.version);
			file_unit = new ASTFileUnit[args.length];
			Kiev.pass_no = 1;
			for(int i=0; i < args.length; i++) {
				try {
					Kiev.curFile = KString.from(args[i]);
					try {
						file_input_stream = new FileInputStream(args[i]);
					} catch( java.io.FileNotFoundException e ) {
						System.gc();
						System.runFinalization();
						System.gc();
						System.runFinalization();
						file_input_stream = new FileInputStream(args[i]);
					}
					kiev005.interface_only = true;
					runGC();
					diff_time = curr_time = System.currentTimeMillis();
					if( Kiev.k == null )
						Kiev.k = new kiev005(file_input_stream);
					else
						Kiev.k.ReInit(file_input_stream);
					file_unit[i] = Kiev.k.FileUnit(args[i]);
					diff_time = System.currentTimeMillis() - curr_time;
					file_unit[i].pass1();
					runGC();
					file_input_stream.close();
					Kiev.curFile = KString.Empty;
					if( Kiev.verbose ) 
						Kiev.reportInfo("Scanned file   "+args[i],diff_time);
					System.out.flush();
					runGC();
				} catch (Exception e) {
					Kiev.reportParserError(0,e);
				}
			}
			if( Kiev.errCount > 0 ) {
				goto stop;
			}
			if( Kiev.project_file != null ) {
				diff_time = curr_time = System.currentTimeMillis();
				Env.dumpProjectFile();
				diff_time = System.currentTimeMillis() - curr_time;
				if( Kiev.verbose ) Kiev.reportInfo("Dumped project file \'"+Kiev.project_file+'\'',diff_time);
			}
			if( Kiev.interface_only ) {
				goto stop;
			}
			Kiev.pass_no = 2;
			diff_time = curr_time = System.currentTimeMillis();
			runGC();
			for(int i=0; i < file_unit.length; i++) {
				if( file_unit[i] == null ) continue;
				try { file_unit[i].pass2();
				} catch (Exception e) {
					Kiev.reportError(0,e); file_unit[i] = null; delayed_stop = true;
				}
			}
			for(int i=0; i < Kiev.files_scanned.length; i++) {
				if( Kiev.files_scanned[i] == null ) continue;
				try { ((ASTFileUnit)Kiev.files_scanned[i]).pass2();
				} catch (Exception e) {
					Kiev.reportError(0,e); Kiev.files_scanned[i] = null; delayed_stop = true;
				}
			}
			runGC();
			Kiev.pass_no = 3;
			for(int i=0; i < file_unit.length; i++) {
				if( file_unit[i] == null ) continue;
				try { file_unit[i].pass2_2();
				} catch (Exception e) {
					Kiev.reportError(0,e); file_unit[i] = null; delayed_stop = true;
				}
			}
			for(int i=0; i < Kiev.files_scanned.length; i++) {
				if( Kiev.files_scanned[i] == null ) continue;
				try { ((ASTFileUnit)Kiev.files_scanned[i]).pass2_2();
				} catch (Exception e) {
					Kiev.reportError(0,e); Kiev.files_scanned[i] = null; delayed_stop = true;
				}
			}
			diff_time = System.currentTimeMillis() - curr_time;
			if( Kiev.verbose ) Kiev.reportInfo("Class's arguments declarations passed",diff_time);
			if( Kiev.errCount > 0 || delayed_stop ) {
				goto stop;
			}
			runGC();
			Kiev.files = new FileUnit[args.length];
			Kiev.pass_no = 4;
			diff_time = curr_time = System.currentTimeMillis();
			for(int i=0; i < file_unit.length; i++) {
				if( file_unit[i] == null ) continue;
				try { Kiev.files[i] = file_unit[i].pass3();
				} catch (Exception e) {
					Kiev.reportError(0,e); file_unit[i] = null; delayed_stop = true;
				}
			}
			for(int i=0; i < Kiev.files_scanned.length; i++) {
				if( Kiev.files_scanned[i] == null ) continue;
				try { ((ASTFileUnit)Kiev.files_scanned[i]).pass3();
				} catch (Exception e) {
					Kiev.reportError(0,e); Kiev.files_scanned[i] = null; delayed_stop = true;
				}
			}
			runGC();
			for(int i=0; i < file_unit.length; i++) {
				if( file_unit[i] == null ) continue;
				try { Kiev.files[i] = file_unit[i].autoProxyMethods();
				} catch (Exception e) {
					Kiev.reportError(0,e); file_unit[i] = null; delayed_stop = true;
				}
			}
			for(int i=0; i < Kiev.files_scanned.length; i++) {
				if( Kiev.files_scanned[i] == null ) continue;
				try { ((ASTFileUnit)Kiev.files_scanned[i]).autoProxyMethods();
				} catch (Exception e) {
					Kiev.reportError(0,e); Kiev.files_scanned[i] = null; delayed_stop = true;
				}
			}
			runGC();
			Kiev.pass_no = 5;
			for(int i=0; i < file_unit.length; i++) {
				if( file_unit[i] == null ) continue;
				try {
					file_unit[i].resolveFinalFields(false);
				} catch (Exception e) {
					Kiev.reportError(0,e); file_unit[i] = null; delayed_stop = true;
				}
			}
			for(int i=0; i < Kiev.files_scanned.length; i++) {
				if( Kiev.files_scanned[i] == null ) continue;
				try {
					((ASTFileUnit)Kiev.files_scanned[i]).resolveFinalFields(true);
					((ASTFileUnit)Kiev.files_scanned[i]).file_unit.cleanup();
				} catch (Exception e) {
					Kiev.reportError(0,e); Kiev.files_scanned[i] = null; delayed_stop = true;
				}
			}
			Kiev.pass_no = 6;
			file_unit = null;
			Kiev.files_scanned = null;
			runGC();
			diff_time = System.currentTimeMillis() - curr_time;
			Kiev.files_scanned = ASTNode.emptyArray;
			runGC();
			if( Kiev.verbose ) Kiev.reportInfo("Class's pure interface declarations passed",diff_time);
			if( Kiev.errCount > 0 ) goto stop;
			for(int i=0; i < Kiev.files.length; i++) {
				try {
					runGC();
					diff_time = curr_time = System.currentTimeMillis();
					Kiev.parseFile(Kiev.files[i]);
					diff_time = System.currentTimeMillis() - curr_time;
					Kiev.curFile = KString.Empty;
				} catch (Exception ioe) {
					Kiev.reportParserError(0,ioe);
					delayed_stop = true;
				}
				if( Kiev.verbose ) 
					Kiev.reportInfo("Parsed file    "+args[i],diff_time);
				runGC();
				try {
					Kiev.files[i].resolve();
				} catch (Exception rte) {
					Kiev.reportError(0,rte);
				}
				runGC();
				if( Kiev.source_only ) {
					if( Kiev.output_dir == null )
						if( Kiev.verbose ) System.out.println("Dumping to Java source file "+args[i]);
					else
						if( Kiev.verbose ) System.out.println("Dumping to Java source file "+args[i]+" into "+Kiev.output_dir+" dir");
					try {
						Kiev.files[i].toJava(Kiev.output_dir);
					} catch (Exception rte) { Kiev.reportError(0,rte); }
				} else {
					try {
						Kiev.files[i].generate();
						runGC();
	//					if( Kiev.output_dir == null )
	//						if( Kiev.verbose ) System.out.println("Dumping to Java bytecodes file "+args[i]);
	//					else
	//						if( Kiev.verbose ) System.out.println("Dumping to Java bytecodes file "+args[i]+" into "+Kiev.output_dir+" dir");
	//					Kiev.files[i].toBytecode(Kiev.output_dir);
						runGC();
					} catch (Exception rte) { Kiev.reportError(0,rte); }
				}
				Kiev.files[i].cleanup();
				Kiev.files[i] = null;
				runGC();
			}
		} catch( Throwable e) {
			if( e.getMessage() != null && e.getMessage().equals("Compilation terminated") ) {
				Env.dumpProjectFile();
				System.exit(0);
			}
			Kiev.reportError(0,e);
			goto stop;
		}

		
stop:
		Env.dumpProjectFile();
		if( Kiev.verbose || Kiev.errCount > 0 )
			Kiev.reportTotals();
		if( !Kiev.interactive ) {
			if( Kiev.errCount > 0 )
				System.exit(1);
			else
				System.exit(0);
			return;
		}
		Kiev.errCount = 0;
		Kiev.warnCount = 0;
		args = getNewArgs();
		goto start;
	}
	
	public static String[] getNewArgs() {
		if( input == null )
			input = new DataInputStream(System.in);
		System.out.print("kiev> ");
		System.out.flush();
		System.gc();
		String cmd = input.readLine();
		if( cmd == null )
			cmd = ":q";
		if( cmd.length() == 0 ) {
			return new String[0];
		}
		if( cmd.startsWith("?") ) {
			System.out.println(
				"[options] file.java ...\t - set options and compile file(s)\n"+
				":q\t\t - quit\n"+
				"?\t\t - this help\n"+
				"{Enter}\t\t - make project\n"
			);
			return getNewArgs();
		}
		if( cmd.startsWith(":q") ) {
			System.out.println("Bye.");
			System.exit(0);
			return null;
		}
		StringTokenizer st = new StringTokenizer(cmd);
		String[] args = new String[st.countTokens()];
		int i=0;
		foreach(String s; st) args[i++] = s;
		return args;
	}
	
	public static void runGC() {
		java.lang.Runtime rt = java.lang.Runtime.getRuntime();
		long old_free = rt.freeMemory()/1024;
		long old_total = rt.totalMemory()/1024;
		long old_busy = old_total - old_free;
		if( Kiev.programm_mem < old_busy ) Kiev.programm_mem = old_busy;
		if( (old_total - old_free) > Kiev.gc_mem ) {
			if( Kiev.verbose ) {
				rt.gc();
				long new_free = rt.freeMemory()/1024;
				long new_total = rt.totalMemory()/1024;
				long new_busy = new_total - new_free;
				System.out.println("[GC (busy/free/total):"+old_busy+"/"+old_free+"/"+old_total+" -> "+new_busy+"/"+new_free+"/"+new_total+" = +"+(new_free-old_free)+" Kb ]");
			} else {
				rt.gc();
			}
		} else {
//			if( Kiev.debug )
//				System.out.println("[Garbage collection skipped: "+(old_total-old_free)+"/"+gc_mem+" Kb ]");
		}
	}

	public static void printHelp() {
			System.out.println("Usage:\njava kiev.Main [-g] [-debug x,y,z,...] [-d output_dir] [-verbose] [-s] [-prompt]\n\t[-classpath search_path] [-gc N] [-verify] file.java ...");
			System.out.println("-g\t- emit classes with debug info and checks");
			System.out.println("-i or -incremental\t- set incremental mode (autoset -make)");
			System.out.println("-d\t- output root dir, default is \'classes\'");
			System.out.println("-v or -verbose\t- verbose operations");
			System.out.println("-s\t- source code generation only (do not produce bytecode)");
			System.out.println("-prompt\t- interactive compilation");
			System.out.println("-verify\t- generate verifyable code");
			System.out.println("-p or -project xxx\t- set project file, default is 'project'");
			System.out.println("-makedep\t- make depend, i.e. only scan files and update project file");
			System.out.println("-make\t- make project files");
			System.out.println("-makeall\t- remake all project files");
			System.out.println("-classpath xxx\t- set search path for classes, default is CLASSPATH env");
			System.out.println("-gc N\t- call garbage collector if memory allocated more than N (in Mb), default N = 8 Mb");
			System.out.println("-debug opt1,opt2,...\t- debug output, options are:");
			System.out.println("\tstat\t- statement generation");
			System.out.println("\tasm\t- assembler generation");
			System.out.println("\tinstr\t- instractions generation");
			System.out.println("\tbcread or/and bcwrite\t- bytecode .class reading or/and generation");
			System.out.println("\tresolv\t- identifier resolving");
			System.out.println("\tflags\t- flags change for members");
			System.out.println("\tmember\t- members attaching (AST generation)");
			System.out.println("\tcreate\t- members creation");
			System.out.println("\tast\t- AST tree");
			System.out.println("\tprofile\t- profile counts");
	}

/** is string not an option and has it embedded '*' or '?' characters?
 */
    static boolean hasWildcards(String s) {
        return
            s.length() > 0 &&
            s.charAt(0) != '-' &&
            (s.indexOf('*') >= 0 || s.indexOf("?") >= 0);
    }

/** does string s[soffset..] match pattern p[poffset..]?
 *  p can contain wildcards.
 */
    static boolean matches(String s, int soffset,
                           String p, int poffset) {
        if (poffset >= p.length())
            return soffset >= s.length();
        else if (p.charAt(poffset) == '*')
            return
                matches(s, soffset, p, poffset + 1) ||
                (soffset < s.length() &&
                 matches(s, soffset + 1, p, poffset));
        else
            return
                soffset < s.length() &&
                (p.charAt(poffset) == '?' ||
                 Character.toUpperCase(s.charAt(soffset)) ==
                 Character.toUpperCase(p.charAt(poffset))) &&
                matches(s, soffset + 1, p, poffset + 1);
    }

	/** add all files matching pattern string s to buffer expargs.
	*/
	static String[] addExpansion(String[] args, int pos) throws IOException {
		String s = args[pos];
		File f = new File(s);
		String path = f.getParent();
		String name = f.getName();
		if (path == null)
			if (s.indexOf(File.separatorChar) == 0) path = "";
			else path = ".";
		File dir = new File(path + File.separatorChar);
		if (dir == null) return args;
		String[] files = dir.list();
		args[pos] = null;
		if (files != null) {
			for (int j = 0; j < files.length; j++) {
				if (matches(files[j], 0, name, 0)) {
					args = (String[])Arrays.appendUniq(args,path + File.separator + files[j]);
				}
			}
		}
		return args;
	}
	
	/** add all files from project file if need to rebuild
	*/
	static String[] addRequaredToMake(String[] args) {
		for(Enumeration<KString> e=Env.projectHash.keys(); e.hasMoreElements();) {
			try {
				KString key = (KString)e.nextElement();
				ProjectFile value = Env.projectHash.get(key);
				File fclass = new File(Kiev.output_dir,value.name.bytecode_name.toString());
				if( fclass.exists() && fclass.isDirectory() ) continue;
				fclass = new File(Kiev.output_dir,value.name.bytecode_name+".class");
				File fjava = value.file;
				if( !fjava.exists() ) continue;
				if( value.bad || !fclass.exists() ) {
					String nm = fjava.toString();
					if( Kiev.verbose ) System.out.println("File "+nm+" - "+value.name.bytecode_name+" "+(value.bad?"is bad":"does not exists"));
					args = (String[])Arrays.appendUniq(args,nm);
					continue;
				}
				long fclass_modified = fclass.lastModified();
				long fjava_modified = fjava.lastModified();
				if( fclass_modified < fjava_modified || Kiev.makeall_project ) {
					String nm = fjava.toString();
					if( !Arrays.contains((Object)args,(Object)nm) ) {
						if( Kiev.verbose ) System.out.println("File "+nm+" - outdated");
						args = (String[])Arrays.append(args,nm);
					}
				}
			} catch ( IOException exc ) {
				continue;
			}
		}
		return args;
	}

}
