package kiev.stdlib;

/** a class for pairs
 * @author      Martin Odersky
 */

public class Pair<A,B> {

    A fst;
    B snd;
    
    public Pair(A fst, B snd) {
    	this.fst = fst;
    	this.snd = snd;
    }

/**
 * a hashcode for this pair.
 */
    public int hashCode() {
	int f = (((Object)fst) == null ? 1 : ((Object)fst).hashCode());
	int s = (((Object)snd) == null ? 1 : ((Object)snd).hashCode());
	return f * s;
    }

/** a binary equality method that also works for `null' operands
 */
    private static boolean equals(Object x, Object y) {
	return (x == null && y == null) || (x != null && x.equals(y));
    }

/** is this pair (structurally) equal to another pair?
 */
    public boolean equals(Object other) {
   	if (other instanceof Pair/*<A,B>*/) {
	    return 
		equals( (Object)fst, (Object)((Pair/*<A,B>*/)other).fst) && 
		equals( (Object)snd, (Object)((Pair/*<A,B>*/)other).snd);
	
	} else {
	    return false;
	}
    }

/** a string representation of this pair
 */
    public String toString() {
	return "Pair(" + fst + ", " + snd + ")";
    }
}
