package Test51;

package {

	import Env;
}

public class Test {

	public static void main(String[] args) {
		if( args.length >= 1 && args[0].equals("-debug") ) {
			PEnv.debug = true;
			String[] ar = new String[args.length-1];
			for(int i=1; i < args.length; i++)
				ar[i-1] = args[i];
			args = ar;
		}

		Type tpObject = newStruct("Object",null).type;
		Type tpAddable = newStruct("Addable",tpObject).type;
		Type tpMultiplyable = newStruct("Multiplyable",tpObject).type;
		Type tpBitable = newStruct("Bitable",tpObject).type;
		Type tpNumber = newStruct("Number",tpObject,new Type[]{tpAddable,tpMultiplyable}).type;
		Type tpIntNumber = newStruct("IntNumber",tpNumber,new Type[]{tpBitable}).type;
		Type tpRealNumber = newStruct("RealNumber",tpNumber).type;
		Type tpByte = newStruct("Byte",tpIntNumber).type;
		Type tpShort = newStruct("Short",tpIntNumber).type;
		Type tpInt = newStruct("Int",tpIntNumber).type;
		Type tpLong = newStruct("Long",tpIntNumber).type;
		Type tpFloat = newStruct("Float",tpRealNumber).type;
		Type tpDouble = newStruct("Double",tpRealNumber).type;
		
		Type tpList = newStruct("List",tpObject,Type.emptyArray,new Type[]{newStruct("List.A",tpObject).type}).type;
		Type tpListInt = newType(tpList,new Type[]{tpInt});
		
		System.out.println(tpObject+" instanceof "+tpObject+" = "+tpObject.instof(tpObject));
		System.out.println(tpNumber+" instanceof "+tpObject+" = "+tpNumber.instof(tpObject));
		PVar<Type> tp = new PVar<Type>();
		foreach( tpInt.instof(tp) )
			System.out.println(tpInt+" instanceof "+tp.$var);
		foreach( tpListInt.instof(tp) )
			System.out.println(tpListInt+" instanceof "+tp.$var);
	}

}

public class Env {

	public static Hash<Struct>		structures = new Hash<Struct>();
	public static Hash<Type>		types = new Hash<Type>();
	
	public static Type newType(Type tp, Type[] args) {
		int hcode = tp.clazz.hashCode();
		foreach(Type t; args) hcode = 37*hcode + t.hashCode();
		Type t = types.get(hcode,fun (Type tt)->boolean {
			if( !tt.clazz.equals(tp.clazz) ) return false;
			if( tt.args.length != args.length ) return false;
			for(int i=0; i < args.length; i++)
				if( !args[i].equals(tt.args[i]) ) return false;
			return true;
		});
		if( t != null ) return t;
		t = new Type(tp.clazz, args);
		types.put(t);
		return t;
	}
	
	public static Struct newStruct(String name, Type sup, Type[] intf, Type[] a) {
		int hcode;
		if( sup != null )
			hcode = 37*name.hashCode() + sup.clazz.hashCode();
		else
			hcode = 37*name.hashCode();
		Struct s = structures.get(hcode,fun (Struct ss)->boolean {
			return ss.name.equals(name) && ss.super_clazz.equals(sup);
		});
		if( s!=null ) return s;
		s = new Struct(name,sup);
		structures.put(s);
		if( intf==null )	s.super_interface = Type.emptyArray;
		else				s.super_interface = intf;
		if( a==null )		s.args = Type.emptyArray;
		else				s.args = a;
		s.type = new Type(s,s.args);
		return s;
	}

	public static Struct newStruct(String name, Type sup, Type[] intf) {
		return newStruct(name, sup, intf, Type.emptyArray);
	}

	public static Struct newStruct(String name, Type sup) {
		return newStruct(name, sup, Type.emptyArray, Type.emptyArray);
	}
}

public class Struct {

	public static Struct[]	emptyArray = new Struct[0];

	public String	name;
	public Type		type;
	public Type[]	args;
	public Type		super_clazz;
	public Type[]	super_interface = Type.emptyArray;

	public Struct(String name, Type sup) {
		this(name,sup,Type.emptyArray,Type.emptyArray);
	}
	
	public Struct(String name, Type sup, Type[] intf) {
		this(name,sup,intf,Type.emptyArray);
	}
	
	public Struct(String name, Type sup, Type[] intf, Type[] a) {
		this.name = name;
		super_clazz = sup;
		if( intf==null )	this.super_interface = Type.emptyArray;
		else				super_interface = intf;
		if( a==null )		this.args = Type.emptyArray;
		else				this.args = a;
	}
	
	public int hashCode() {
		int hcode;
		if( super_clazz != null )
			hcode = 37*name.hashCode() + super_clazz.clazz.hashCode();
		else
			hcode = 37*name.hashCode();
		return hcode;
	}
}

public class Type {

	public static Type[] emptyArray = new Type[0];
	
	forward public	Struct	clazz;
	public			Type[]	args;
	
	public Type(Struct s, Type[] args) {
		clazz = s;
		this.args = args;
	}
	
	public Type(Struct s) {
		this(s,Type.emptyArray);
	}
	
	public int hashCode() {
		int hcode = clazz.hashCode();
		foreach(Type t; args) hcode = 37*hcode + t.hashCode();
		return hcode;
	}

	public String toString() {
		if( args.length == 0 )
			return clazz.name;
		else {
			StringBuffer sb = new StringBuffer();
			sb.append(clazz.name).append('<');
			for(int i=0; i < args.length; i++) {
				sb.append(args[i]);
				if( i < args.length-1 ) sb.append(',');
			}
			sb.append('>');
			return sb.toString();
		}
	}
	
	rule direct_super_type(pvar Type tp) {
		tp ?= clazz.super_clazz
	;	tp @= clazz.super_interface
	}
	
	rule super_type(pvar Type tp)
		pvar Type tp1;
	{
		direct_super_type(tp)
	;	direct_super_type(tp1), tp1.super_type(tp)
	}
	
	rule instof(pvar Type tp)
	{
		tp ?= this
	;	super_type(tp)
	}
	
	boolean equals(Type tp) {
		if( tp == null ) return false;
		if( !clazz.name.equals(tp.clazz.name) ) return false;
		if( clazz.super_clazz==null ) {
			if( tp.clazz.super_clazz != null ) return false;
		}
		else if( !clazz.super_clazz.equals(tp.clazz.super_clazz) ) return false;
		if( !args_equals(tp) ) return false;
		return true;
	}
	
	rule eq(Type tp)
	{
		clazz.name.equals(tp.clazz.name),
		{ clazz.super_clazz == null, tp.clazz.super_clazz == null
		; clazz.super_clazz != null, tp.clazz.super_clazz != null, clazz.super_clazz.eq(tp.clazz.super_clazz)
		},
		args_equals(tp)
	}
	
	boolean args_equals(Type tp) {
		if( args.length != tp.args.length ) return false;
		for(int i=0; i < args.length; i++)
			if( !args[i].equals(tp.args[i]) ) return false;
		return true;
	}
}

